/*    pwgen.c - main module for PWGEN program
**    Copyright (C) 1999  Adel I. Mirzazhanov <adel@altair.alatau.kz>
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License as published by
**    the Free Software Foundation; either version 2 of the License, or
**    (at your option) any later version.
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*==========================================================
** NAME		pwgen.c
** TYPE		MAIN PROGRAM MODULE
** DESCRIPTION	main module of PWGEN program
** INPUT	SEE DOCUMENTATION
** OUTPUT	SEE DOCUMENTATION
** RETURN	0	- SUCCESSFUL
**		-1	- UNSUCCESSFUL
**
** STARTTED AT	07/07/99
** AUTHOR	ADEL I. MIRZAZHANOV
** ENDED AT	DD/MM/YY
==========================================================*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <getopt.h>
#include "pwgen.h"
/*============== MAIN ===============*/
int main(int argc, char *argv[])
    {
     int i = 0;
     int j = 0;
     
     int option;                     /* programm option */
     char pass_str[256];                 /* password string */
/*     bzero(pass_str, 256);*/
     unsigned int pass_mode = 0;         /* password generation mode*/
     unsigned int pass_mode_present = 0; /* flag */
     int pass_length = 0;
     int pass_length_present = 0;
     int number_of_pass = 0;
     int number_of_pass_present = 0;
     int user_defined_seq = 0;
     int user_defined_seq_present = 0;
     
/*
** Analize options
*/
     while((option = getopt(argc, argv, "SNCLrn:l:h")) != -1)
         {
	  switch(option)
	      {
	       case 'S':
	          pass_mode = pass_mode|S_SPC;
		  pass_mode_present = 1;
		  break;
	       case 'N':
	          pass_mode = pass_mode|S_NUM;
		  pass_mode_present = 1;
		  break;
	       case 'C':
	          pass_mode = pass_mode|S_CLT;
		  pass_mode_present = 1;
		  break;
	       case 'L':
	          pass_mode = pass_mode|S_LET;
		  pass_mode_present = 1;
		  break;
	       case 'r':
	          user_defined_seq = get_random_seq();
		  user_defined_seq_present = 1;
		  break;
	       case 'n':
	          number_of_pass = atoi(optarg);
		  number_of_pass_present = 1;
		  break;
	       case 'l':
	          pass_length = atoi(optarg);
		  pass_length_present = 1;
		  break;
	       case 'h':
	          print_help();
		  return(0);
	       default:
		  print_help();
		  exit(-1);
	      }
	 }
     if(pass_mode_present != 1)
         pass_mode = 15;
     if(pass_length_present != 1)
         pass_length = 8;
     if(number_of_pass_present != 1)
         number_of_pass = 10;
     if(user_defined_seq_present != 1)
         srand(gen_random_seed());
     else
         {
	  printf("\nUser random seed: %d\n", user_defined_seq);
          srand(user_defined_seq|gen_random_seed());
         }
     for(j=0; j <= number_of_pass-1; j++)
         {
          gen_password(pass_str, pass_length, pass_mode);
          for(i=0; i <= pass_length-1; i++)
             printf("%c",pass_str[i]);
          printf("\n");
         }
     return(0);
    }
